> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create a deployment template

POST https://rest.test.zuora.com/deployment-manager/deployment_templates
Content-Type: application/json

Creates templates based on user preference.
There are 2 ways to select components.
  - Selecting the whole component.
  - Advanced Options -> which helps user to select specific components to be migrated.

It takes the enviroment details from the logged in user automatically, while creating the template.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/deployment-manager/configuration-templates/post-deployment-template

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

### Body (application/json)

This endpoint expects a CreateTemplateRequestContent.

- `description` (string, required) — Creates template description.
- `name` (string, required) — Name of the Template.
- `templateTenant` (string, required) — ID of the template tenant.
- `content` (SettingSourceComponentResponse, optional) — Provides details about the different components that need to be compared and deployed.
- `customFields` (boolean, optional) — Selected custom fields component or not.
- `customObjects` (boolean, optional) — Selected custom objects component or not.
- `notifications` (boolean, optional) — Selected Notification component or not.
- `selectedComponents` (list of ConfigurationTemplateContent, optional) — ConfigurationTemplateContent object contains the selected meta data information.
- `settings` (boolean, optional) — Selected Settings component or not.
- `workflows` (boolean, optional) — Selected Workflow component or not.

## Response

### 200

Successfully created the template.

- `active` (boolean, optional) — Whether or not the template is active.
- `content` (SettingSourceComponentResponse, optional) — Provides details about the different components that need to be compared and deployed.
- `createdBy` (string, optional) — Information about the user who created it.
- `createdOn` (string, optional) — When it is created.
- `description` (string, optional) — Template description which contains the information about the created template.
- `entityName` (string, optional) — Name of the Entity
- `environment` (string, optional) — Details of the environment in which the template was created.
- `errors` (string, optional) — Error information.
- `id` (string, optional) — Id of the template.
- `name` (string, optional) — Name of the template.
- `status` (string, optional) — The status of the template creation, such as whether it is in progress, completed, or failed.
- `tenantName` (string, optional) — Tenant's name for whom the template is created.

### 201

created. The request has been fulfilled and resulted in a new resource being created. The newly created resource can be referenced by the URL(s) returned in the entity of the response, with the most specific URL for the resource given by a Location header field.

## Errors

### 400 Bad Request Error

Bad Request

- `reasons` (list of ConfigTemplateErrorResponseReasonsItems, optional)

### 401 Unauthorized Error

Unauthorized

- `reasons` (list of ConfigTemplateErrorResponseReasonsItems, optional)

### 403 Forbidden Error

Forbidden

- `reasons` (list of ConfigTemplateErrorResponseReasonsItems, optional)

### 404 Not Found Error

Not Found

- `reasons` (list of ConfigTemplateErrorResponseReasonsItems, optional)

## Types

### SettingSourceComponentResponse

Provides details about the different components that need to be compared and deployed.

- `customFields` (list of SettingComponentKeyValue, optional)
- `customObjects` (list of SettingComponentKeyValue, optional)
- `dataAccessControl` (list of SettingComponentKeyValue, optional)
- `dataQuery` (list of SettingComponentKeyValue, optional)
- `multiOrg` (list of SettingComponentKeyValue, optional)
- `notifications` (list of SettingComponentKeyValue, optional)
- `organizationHierarchy` (list of SettingComponentKeyValue, optional)
- `productCatalog` (list of SettingComponentKeyValue, optional)
- `settings` (list of SettingComponentKeyValue, optional)
- `workflows` (list of SettingComponentKeyValue, optional)

### ConfigurationTemplateContent

It contains information about template schemas with segregation keys.

- `componentType` (string, optional) — Type of Component.
- `error` (string, optional) — Error Information.
- `id` (string, optional) — Id of Each component.
- `key` (string, optional) — Key value of fields inside component.
- `method` (string, optional) — Http method which is used to retrieve the particular component.
- `payload` (JsonNode, optional) — Json node object contains metadata.
- `result` (string, optional) — Contains the response of details fetched regarding selected component.
- `segregationKey` (string, optional) — Gives the difference between components and sub components.
- `templateId` (string, optional) — Id of the Template.
- `url` (string, optional) — Metadata is retrieved from this URL.

### ConfigTemplateErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — A detailed description of the error response.

### SettingComponentKeyValue

Provides details about the individual components that need to be compared and deployed.

- `errors` (list of string, optional)
- `originalPayload` (JsonNode, optional) — Json node object contains metadata.
- `response` (list of ConfigurationTemplateContent, optional)
- `segregationKeys` (list of string, optional)

### JsonNode

Json node object contains metadata.

## Examples

### response

**Request**

```json
{
  "description": "string",
  "name": "string",
  "templateTenant": "80b3f8cd-5801-4ed7-bee7-ad1569916c2f"
}
```

**Response**

```json
{
  "active": true,
  "createdBy": "Daco user",
  "createdOn": "2022-09-14T16:06:43.155Z",
  "description": "",
  "entityName": "Global",
  "environment": "US-API-Sandbox-Staging",
  "errors": "-",
  "id": "210656b3-0d89-4bc6-92b9-634653e729af",
  "name": "Test_Template",
  "status": "Inprogress",
  "tenantName": "Data Connect"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/deployment-manager/deployment_templates"

payload = {
    "description": "string",
    "name": "string",
    "templateTenant": "80b3f8cd-5801-4ed7-bee7-ad1569916c2f"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/deployment-manager/deployment_templates';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"description":"string","name":"string","templateTenant":"80b3f8cd-5801-4ed7-bee7-ad1569916c2f"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/deployment-manager/deployment_templates"

	payload := strings.NewReader("{\n  \"description\": \"string\",\n  \"name\": \"string\",\n  \"templateTenant\": \"80b3f8cd-5801-4ed7-bee7-ad1569916c2f\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/deployment-manager/deployment_templates")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"description\": \"string\",\n  \"name\": \"string\",\n  \"templateTenant\": \"80b3f8cd-5801-4ed7-bee7-ad1569916c2f\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/deployment-manager/deployment_templates")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"description\": \"string\",\n  \"name\": \"string\",\n  \"templateTenant\": \"80b3f8cd-5801-4ed7-bee7-ad1569916c2f\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/deployment-manager/deployment_templates', [
  'body' => '{
  "description": "string",
  "name": "string",
  "templateTenant": "80b3f8cd-5801-4ed7-bee7-ad1569916c2f"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/deployment-manager/deployment_templates");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"description\": \"string\",\n  \"name\": \"string\",\n  \"templateTenant\": \"80b3f8cd-5801-4ed7-bee7-ad1569916c2f\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "description": "string",
  "name": "string",
  "templateTenant": "80b3f8cd-5801-4ed7-bee7-ad1569916c2f"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/deployment-manager/deployment_templates")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Example 2

**Request**

```json
{
  "description": "string",
  "name": "string",
  "templateTenant": "80b3f8cd-5801-4ed7-bee7-ad1569916c2f"
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/deployment-manager/deployment_templates"

payload = {
    "description": "string",
    "name": "string",
    "templateTenant": "80b3f8cd-5801-4ed7-bee7-ad1569916c2f"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/deployment-manager/deployment_templates';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"description":"string","name":"string","templateTenant":"80b3f8cd-5801-4ed7-bee7-ad1569916c2f"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/deployment-manager/deployment_templates"

	payload := strings.NewReader("{\n  \"description\": \"string\",\n  \"name\": \"string\",\n  \"templateTenant\": \"80b3f8cd-5801-4ed7-bee7-ad1569916c2f\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/deployment-manager/deployment_templates")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"description\": \"string\",\n  \"name\": \"string\",\n  \"templateTenant\": \"80b3f8cd-5801-4ed7-bee7-ad1569916c2f\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/deployment-manager/deployment_templates")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"description\": \"string\",\n  \"name\": \"string\",\n  \"templateTenant\": \"80b3f8cd-5801-4ed7-bee7-ad1569916c2f\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/deployment-manager/deployment_templates', [
  'body' => '{
  "description": "string",
  "name": "string",
  "templateTenant": "80b3f8cd-5801-4ed7-bee7-ad1569916c2f"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/deployment-manager/deployment_templates");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"description\": \"string\",\n  \"name\": \"string\",\n  \"templateTenant\": \"80b3f8cd-5801-4ed7-bee7-ad1569916c2f\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "description": "string",
  "name": "string",
  "templateTenant": "80b3f8cd-5801-4ed7-bee7-ad1569916c2f"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/deployment-manager/deployment_templates")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```